#if !defined(AFX_EVENTQUE_H__5AE2472E_9CE1_4BB8_9150_339098524E29__INCLUDED_)
#define AFX_EVENTQUE_H__5AE2472E_9CE1_4BB8_9150_339098524E29__INCLUDED_

#include <afxtempl.h>
#include <afxmt.h>

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// Cxgt̃L[
/////////////////////////////////////////////////////////////////////////////

template<class T>
class CEventQue
{
public:
	// RXgN^
	CEventQue();
	// fXgN^
	virtual ~CEventQue();

public:
	// L[擾
	CArray<T, T>& Get();
	// L[ɒǉ
	void Add(T value);
	// Cxg𔭐
	void SetEvent();
	// L[NAB
	void Clear();

private:
	CArray<T, T> m_que;
	CArray<T, T> m_queWork;
	CCriticalSection m_cs;
	CEvent m_event;
};

//---------------------------------------------------------------------------
// RXgN^
//---------------------------------------------------------------------------
template<class T>
CEventQue<T>::CEventQue()
{
}

//---------------------------------------------------------------------------
// fXgN^
//---------------------------------------------------------------------------
template<class T>
CEventQue<T>::~CEventQue()
{
}

//---------------------------------------------------------------------------
// L[擾
//---------------------------------------------------------------------------
template<class T>
CArray<T, T>& CEventQue<T>::Get()
{
	CSingleLock slk_event(&m_event);
	CSingleLock slk_cs(&m_cs);

	slk_event.Lock();

	slk_cs.Lock();
	m_queWork.RemoveAll();
	m_queWork.Append(m_que);
	m_que.RemoveAll();
	slk_cs.Unlock();

	slk_event.Unlock();

	return m_queWork;
}

//---------------------------------------------------------------------------
// L[ɒǉ
//---------------------------------------------------------------------------
template<class T>
void CEventQue<T>::Add(T value)
{
	CSingleLock slk_cs(&m_cs);

	slk_cs.Lock();
	m_que.Add(value);
	slk_cs.Unlock();

	SetEvent();
}

//---------------------------------------------------------------------------
// Cxg𔭐
//---------------------------------------------------------------------------
template<class T>
void CEventQue<T>::SetEvent()
{
	m_event.SetEvent();
}


//---------------------------------------------------------------------------
// L[NAB
//---------------------------------------------------------------------------
template<class T>
void CEventQue<T>::Clear()
{
	CSingleLock slk_cs(&m_cs);

	slk_cs.Lock();
	m_que.RemoveAll();
	slk_cs.Unlock();
}

#endif // !defined(AFX_EVENTQUE_H__5AE2472E_9CE1_4BB8_9150_339098524E29__INCLUDED_)
